Index: crt/locale/locale.c
===================================================================
--- crt/locale/locale.c	(revision 47065)
+++ crt/locale/locale.c	(working copy)
@@ -244,396 +198,1108 @@
   return CONTINUE_LOOKING;
 }
 
+extern int atoi(const char *);
+
 /* Internal: Find the LCID for a locale specification */
-static LCID MSVCRT_locale_to_LCID(locale_search_t* locale)
+static LCID MSVCRT_locale_to_LCID(const char *locale)
 {
-  LCID lcid;
-  EnumResourceLanguagesA(GetModuleHandleA("KERNEL32"), (LPSTR)RT_STRING,
-			 (LPCSTR)LOCALE_ILANGUAGE,find_best_locale_proc,
-			 (LONG_PTR)locale);
+    LCID lcid;
+    locale_search_t search;
+    char *cp, *region;
 
-  if (!locale->match_flags)
-    return 0;
+    memset(&search, 0, sizeof(locale_search_t));
 
-  /* If we were given something that didn't match, fail */
-  if (locale->search_country[0] && !(locale->match_flags & FOUND_COUNTRY))
-    return 0;
+    cp = strchr(locale, '.');
+    region = strchr(locale, '_');
 
-  lcid =  MAKELCID(locale->found_lang_id, SORT_DEFAULT);
+    lstrcpynA(search.search_language, locale, MAX_ELEM_LEN);
+    if(region) {
+        lstrcpynA(search.search_country, region+1, MAX_ELEM_LEN);
+        if(region-locale < MAX_ELEM_LEN)
+            search.search_language[region-locale] = '\0';
+    } else
+        search.search_country[0] = '\0';
 
-  /* Populate partial locale, translating LCID to locale string elements */
-  if (!locale->found_codepage[0])
-  {
-    /* Even if a codepage is not enumerated for a locale
-     * it can be set if valid */
-    if (locale->search_codepage[0])
-    {
-      if (IsValidCodePage(atoi(locale->search_codepage)))
-        memcpy(locale->found_codepage,locale->search_codepage,MAX_ELEM_LEN);
-      else
-      {
-        /* Special codepage values: OEM & ANSI */
-        if (_stricmp(locale->search_codepage,"OCP"))
-        {
-          GetLocaleInfoA(lcid, LOCALE_IDEFAULTCODEPAGE,
-                         locale->found_codepage, MAX_ELEM_LEN);
+    if(cp) {
+        lstrcpynA(search.search_codepage, cp+1, MAX_ELEM_LEN);
+        if(cp-region-1 < MAX_ELEM_LEN)
+          search.search_country[cp-region-1] = '\0';
+        if(cp-locale < MAX_ELEM_LEN)
+            search.search_language[cp-locale] = '\0';
+    } else
+        search.search_codepage[0] = '\0';
+
+    /* FIXME:  MSVCRT_locale_to_LCID is not finding remaped values */
+    remap_synonym(search.search_country);
+
+    EnumResourceLanguagesA(GetModuleHandleA("KERNEL32"), (LPSTR)RT_STRING,
+            (LPCSTR)LOCALE_ILANGUAGE,find_best_locale_proc,
+            (LONG_PTR)&search);
+
+    if (!search.match_flags)
+        return -1;
+
+    /* If we were given something that didn't match, fail */
+    if (search.search_country[0] && !(search.match_flags & FOUND_COUNTRY))
+        return -1;
+
+    lcid =  MAKELCID(search.found_lang_id, SORT_DEFAULT);
+
+    /* Populate partial locale, translating LCID to locale string elements */
+    if (!search.found_codepage[0]) {
+        /* Even if a codepage is not enumerated for a locale
+         * it can be set if valid */
+        if (search.search_codepage[0]) {
+            if (IsValidCodePage(atoi(search.search_codepage)))
+                memcpy(search.found_codepage,search.search_codepage,MAX_ELEM_LEN);
+            else {
+                /* Special codepage values: OEM & ANSI */
+                if (strcasecmp(search.search_codepage,"OCP")) {
+                    GetLocaleInfoA(lcid, LOCALE_IDEFAULTCODEPAGE,
+                            search.found_codepage, MAX_ELEM_LEN);
+                } else if (strcasecmp(search.search_codepage,"ACP")) {
+                    GetLocaleInfoA(lcid, LOCALE_IDEFAULTANSICODEPAGE,
+                            search.found_codepage, MAX_ELEM_LEN);
+                } else
+                    return -1;
+
+                if (!atoi(search.found_codepage))
+                    return -1;
+            }
+        } else {
+            /* Prefer ANSI codepages if present */
+            GetLocaleInfoA(lcid, LOCALE_IDEFAULTANSICODEPAGE,
+                    search.found_codepage, MAX_ELEM_LEN);
+            if (!search.found_codepage[0] || !atoi(search.found_codepage))
+                GetLocaleInfoA(lcid, LOCALE_IDEFAULTCODEPAGE,
+                        search.found_codepage, MAX_ELEM_LEN);
         }
-        if (_stricmp(locale->search_codepage,"ACP"))
-        {
-          GetLocaleInfoA(lcid, LOCALE_IDEFAULTANSICODEPAGE,
-                         locale->found_codepage, MAX_ELEM_LEN);
+    }
+
+    GetLocaleInfoA(lcid, LOCALE_SENGLANGUAGE|LOCALE_NOUSEROVERRIDE,
+            search.found_language, MAX_ELEM_LEN);
+    GetLocaleInfoA(lcid, LOCALE_SENGCOUNTRY|LOCALE_NOUSEROVERRIDE,
+            search.found_country, MAX_ELEM_LEN);
+    return lcid;
+}
+
+/* INTERNAL: Set lc_handle, lc_id and lc_category in threadlocinfo struct */
+static BOOL update_threadlocinfo_category(LCID lcid, _locale_t loc, int category)
+{
+    char buf[256], *p;
+    int len;
+
+    if(GetLocaleInfoA(lcid, LOCALE_ILANGUAGE, buf, 256)) {
+        p = buf;
+
+        loc->locinfo->lc_id[category].wLanguage = 0;
+        while(*p) {
+            loc->locinfo->lc_id[category].wLanguage *= 16;
+
+            if(*p <= '9')
+                loc->locinfo->lc_id[category].wLanguage += *p-'0';
+            else
+                loc->locinfo->lc_id[category].wLanguage += *p-'a'+10;
+
+            p++;
         }
-        else
-          return 0;
 
-        if (!atoi(locale->found_codepage))
-           return 0;
-      }
+        loc->locinfo->lc_id[category].wCountry =
+            loc->locinfo->lc_id[category].wLanguage;
     }
-    else
-    {
-      /* Prefer ANSI codepages if present */
-      GetLocaleInfoA(lcid, LOCALE_IDEFAULTANSICODEPAGE,
-                     locale->found_codepage, MAX_ELEM_LEN);
-      if (!locale->found_codepage[0] || !atoi(locale->found_codepage))
-          GetLocaleInfoA(lcid, LOCALE_IDEFAULTCODEPAGE,
-                         locale->found_codepage, MAX_ELEM_LEN);
+
+    if(GetLocaleInfoA(lcid, LOCALE_IDEFAULTANSICODEPAGE, buf, 256))
+        loc->locinfo->lc_id[category].wCodePage = atoi(buf);
+
+    loc->locinfo->lc_handle[category] = lcid;
+
+    len = 0;
+    len += GetLocaleInfoA(lcid, LOCALE_SLANGUAGE, buf, 256);
+    buf[len-1] = '_';
+    len += GetLocaleInfoA(lcid, LOCALE_SCOUNTRY, &buf[len], 256-len);
+    buf[len-1] = '.';
+    len += GetLocaleInfoA(lcid, LOCALE_IDEFAULTANSICODEPAGE, &buf[len], 256-len);
+
+    loc->locinfo->lc_category[category].locale = malloc(sizeof(char[len]));
+    loc->locinfo->lc_category[category].refcount = malloc(sizeof(int));
+    if(!loc->locinfo->lc_category[category].locale
+            || !loc->locinfo->lc_category[category].refcount) {
+        free(loc->locinfo->lc_category[category].locale);
+        free(loc->locinfo->lc_category[category].refcount);
+        loc->locinfo->lc_category[category].locale = NULL;
+        loc->locinfo->lc_category[category].refcount = NULL;
+        return TRUE;
     }
-  }
-  GetLocaleInfoA(lcid, LOCALE_SENGLANGUAGE|LOCALE_NOUSEROVERRIDE,
-                 locale->found_language, MAX_ELEM_LEN);
-  GetLocaleInfoA(lcid, LOCALE_SENGCOUNTRY|LOCALE_NOUSEROVERRIDE,
-                 locale->found_country, MAX_ELEM_LEN);
-  return lcid;
+    memcpy(loc->locinfo->lc_category[category].locale, buf, sizeof(char[len]));
+    *loc->locinfo->lc_category[category].refcount = 1;
+
+    return FALSE;
 }
 
-/* INTERNAL: Set ctype behaviour for a codepage */
-static void msvcrt_set_ctype(unsigned int codepage, LCID lcid)
-{
-  CPINFO cp;
+/* INTERNAL: swap pointers values */
+static inline void swap_pointers(void **p1, void **p2) {
+    void *hlp;
 
-  memset(&cp, 0, sizeof(CPINFO));
+    hlp = *p1;
+    *p1 = *p2;
+    *p2 = hlp;
+}
 
-  if (GetCPInfo(codepage, &cp))
-  {
-    int i;
-    char str[3];
-    unsigned char *traverse = cp.LeadByte;
+/* INTERNAL: returns _locale_t struct for current locale */
+_locale_t get_locale(void) {
+    MSVCRT_thread_data *data = msvcrt_get_thread_data();
 
-    memset(MSVCRT_current_ctype, 0, sizeof(MSVCRT__ctype));
-    MSVCRT___lc_codepage = codepage;
-    MSVCRT___lc_collate_cp = codepage;
+    if(!data || !data->locale)
+        return MSVCRT_locale;
 
-    /* Switch ctype macros to MBCS if needed */
-    __mb_cur_max = cp.MaxCharSize;
+    return data->locale;
+}
 
-    /* Set remaining ctype flags: FIXME: faster way to do this? */
-    str[1] = str[2] = 0;
-    for (i = 0; i < 256; i++)
-    {
-      if (!(MSVCRT__pctype[i] & MSVCRT_LEADBYTE))
-      {
-        str[0] = i;
-        GetStringTypeA(lcid, CT_CTYPE1, str, 1, MSVCRT__pctype + i);
-      }
+/* INTERNAL: constructs string returned by setlocale */
+static inline char* construct_lc_all(_locale_t cur) {
+    static char current_lc_all[MAX_LOCALE_LENGTH];
+
+    int i;
+
+    for(i=MSVCRT_LC_MIN+1; i<MSVCRT_LC_MAX; i++) {
+        if(strcmp(cur->locinfo->lc_category[i].locale,
+                    cur->locinfo->lc_category[i+1].locale))
+            break;
     }
 
-    /* Set leadbyte flags */
-    while (traverse[0] || traverse[1])
-    {
-      for( i = traverse[0]; i <= traverse[1]; i++ )
-        MSVCRT_current_ctype[i+1] |= MSVCRT_LEADBYTE;
-      traverse += 2;
-    };
-  }
+    if(i==MSVCRT_LC_MAX)
+        return cur->locinfo->lc_category[MSVCRT_LC_COLLATE].locale;
+
+    sprintf(current_lc_all,
+            "LC_COLLATE=%s;LC_CTYPE=%s;LC_MONETARY=%s;LC_NUMERIC=%s;LC_TIME=%s",
+            cur->locinfo->lc_category[MSVCRT_LC_COLLATE].locale,
+            cur->locinfo->lc_category[MSVCRT_LC_CTYPE].locale,
+            cur->locinfo->lc_category[MSVCRT_LC_MONETARY].locale,
+            cur->locinfo->lc_category[MSVCRT_LC_NUMERIC].locale,
+            cur->locinfo->lc_category[MSVCRT_LC_TIME].locale);
+
+    return current_lc_all;
 }
 
 
-/*
- * @implemented
+/*********************************************************************
+ *		wsetlocale (MSVCRT.@)
  */
-char *setlocale(int category, const char *locale)
+MSVCRT_wchar_t* CDECL _wsetlocale(int category, const MSVCRT_wchar_t* locale)
 {
-  LCID lcid = 0;
-  locale_search_t lc;
-  int haveLang, haveCountry, haveCP;
-  char* next;
-  int lc_all = 0;
+  static MSVCRT_wchar_t fake[] = {
+    'E','n','g','l','i','s','h','_','U','n','i','t','e','d',' ',
+    'S','t','a','t','e','s','.','1','2','5','2',0 };
 
-  TRACE("(%d %s)\n",category,locale);
+  FIXME("%d %s\n", category, debugstr_w(locale));
 
-  if (category < MSVCRT_LC_MIN || category > MSVCRT_LC_MAX)
-    return NULL;
+  return fake;
+}
 
-  if (locale == NULL)
-  {
-    /* Report the current Locale */
-    return MSVCRT_current_lc_all;
-  }
+/*********************************************************************
+ *		_Getdays (MSVCRT.@)
+ */
+const char* CDECL _Getdays(void)
+{
+  static const char MSVCRT_days[] = ":Sun:Sunday:Mon:Monday:Tue:Tuesday:Wed:"
+                            "Wednesday:Thu:Thursday:Fri:Friday:Sat:Saturday";
+  /* FIXME: Use locale */
+  TRACE("(void) semi-stub\n");
+  return MSVCRT_days;
+}
 
-  LOCK_LOCALE;
+/*********************************************************************
+ *		_Getmonths (MSVCRT.@)
+ */
+const char* CDECL _Getmonths(void)
+{
+  static const char MSVCRT_months[] = ":Jan:January:Feb:February:Mar:March:Apr:"
+                "April:May:May:Jun:June:Jul:July:Aug:August:Sep:September:Oct:"
+                "October:Nov:November:Dec:December";
+  /* FIXME: Use locale */
+  TRACE("(void) semi-stub\n");
+  return MSVCRT_months;
+}
 
-  if (locale[0] == 'L' && locale[1] == 'C' && locale[2] == '_')
-  {
-    WARN(":restore previous locale not implemented!\n");
-    /* FIXME: Easiest way to do this is parse the string and
-     * call this function recursively with its elements,
-     * Where they differ for each lc_ type.
-     */
-    UNLOCK_LOCALE;
-    return MSVCRT_current_lc_all;
-  }
+/*********************************************************************
+ *		_Gettnames (MSVCRT.@)
+ */
+const char* CDECL _Gettnames(void)
+{
+  /* FIXME: */
+  TRACE("(void) stub\n");
+  return "";
+}
 
-  /* Default Locale: Special case handling */
-  if (!strlen(locale) || ((toupper(locale[0]) == 'C') && !locale[1]))
-  {
-    MSVCRT_current_lc_all[0] = 'C';
-    MSVCRT_current_lc_all[1] = '\0';
-    MSVCRT___lc_codepage = GetACP();
-    MSVCRT___lc_collate_cp = GetACP();
+/*********************************************************************
+ *		_Strftime (MSVCRT.@)
+ */
+const char* CDECL _Strftime(char *out, unsigned int len, const char *fmt,
+                            const void *tm, void *foo)
+{
+  /* FIXME: */
+  TRACE("(%p %d %s %p %p) stub\n", out, len, fmt, tm, foo);
+  return "";
+}
 
-    switch (category) {
-    case MSVCRT_LC_ALL:
-      lc_all = 1; /* Fall through all cases ... */
-    case MSVCRT_LC_COLLATE:
-      if (!lc_all) break;
-    case MSVCRT_LC_CTYPE:
-      /* Restore C locale ctype info */
-      __mb_cur_max = 1;
-      memcpy(MSVCRT_current_ctype, MSVCRT__ctype, sizeof(MSVCRT__ctype));
-      if (!lc_all) break;
-    case MSVCRT_LC_MONETARY:
-      if (!lc_all) break;
-    case MSVCRT_LC_NUMERIC:
-      if (!lc_all) break;
-    case MSVCRT_LC_TIME:
-      break;
+/*********************************************************************
+ *		__crtLCMapStringA (MSVCRT.@)
+ */
+int CDECL __crtLCMapStringA(
+  LCID lcid, DWORD mapflags, const char* src, int srclen, char* dst,
+  int dstlen, unsigned int codepage, int xflag
+) {
+  FIXME("(lcid %x, flags %x, %s(%d), %p(%d), %x, %d), partial stub!\n",
+        lcid,mapflags,src,srclen,dst,dstlen,codepage,xflag);
+  /* FIXME: A bit incorrect. But msvcrt itself just converts its
+   * arguments to wide strings and then calls LCMapStringW
+   */
+  return LCMapStringA(lcid,mapflags,src,srclen,dst,dstlen);
+}
+
+/*********************************************************************
+ *		__crtCompareStringA (MSVCRT.@)
+ */
+int CDECL __crtCompareStringA( LCID lcid, DWORD flags, const char *src1, int len1,
+                               const char *src2, int len2 )
+{
+    FIXME("(lcid %x, flags %x, %s(%d), %s(%d), partial stub\n",
+          lcid, flags, debugstr_a(src1), len1, debugstr_a(src2), len2 );
+    /* FIXME: probably not entirely right */
+    return CompareStringA( lcid, flags, src1, len1, src2, len2 );
+}
+
+/*********************************************************************
+ *		__crtCompareStringW (MSVCRT.@)
+ */
+int CDECL __crtCompareStringW( LCID lcid, DWORD flags, const MSVCRT_wchar_t *src1, int len1,
+                               const MSVCRT_wchar_t *src2, int len2 )
+{
+    FIXME("(lcid %x, flags %x, %s(%d), %s(%d), partial stub\n",
+          lcid, flags, debugstr_w(src1), len1, debugstr_w(src2), len2 );
+    /* FIXME: probably not entirely right */
+    return CompareStringW( lcid, flags, src1, len1, src2, len2 );
+}
+
+/*********************************************************************
+ *		__crtGetLocaleInfoW (MSVCRT.@)
+ */
+int CDECL __crtGetLocaleInfoW( LCID lcid, LCTYPE type, MSVCRT_wchar_t *buffer, int len )
+{
+    FIXME("(lcid %x, type %x, %p(%d), partial stub\n", lcid, type, buffer, len );
+    /* FIXME: probably not entirely right */
+    return GetLocaleInfoW( lcid, type, buffer, len );
+}
+
+/*********************************************************************
+ *              btowc(MSVCRT.@)
+ */
+wint_t CDECL btowc(int c)
+{
+    _locale_t locale = get_locale();
+    unsigned char letter = c;
+    wchar_t ret;
+
+    if(!MultiByteToWideChar(locale->locinfo->lc_handle[MSVCRT_LC_CTYPE],
+                0, (LPCSTR)&letter, 1, &ret, 1))
+        return 0;
+
+    return ret;
+}
+
+/*********************************************************************
+ *              __crtGetStringTypeW(MSVCRT.@)
+ *
+ * This function was accepting different number of arguments in older
+ * versions of msvcrt.
+ */
+BOOL CDECL __crtGetStringTypeW(DWORD unk, DWORD type,
+        MSVCRT_wchar_t *buffer, int len, WORD *out)
+{
+    FIXME("(unk %x, type %x, wstr %p(%d), %p) partial stub\n",
+            unk, type, buffer, len, out);
+
+    return GetStringTypeW(type, buffer, len, out);
+}
+
+/*********************************************************************
+ *		localeconv (MSVCRT.@)
+ */
+struct lconv * CDECL localeconv(void)
+{
+    return get_locale()->locinfo->lconv;
+}
+
+/*********************************************************************
+ *		__lconv_init (MSVCRT.@)
+ */
+void CDECL __lconv_init(void)
+{
+    /* this is used to make chars unsigned */
+    charmax = 255;
+}
+
+/*********************************************************************
+ *      ___lc_handle_func (MSVCRT.@)
+ */
+HANDLE * CDECL ___lc_handle_func(void)
+{
+    return MSVCRT___lc_handle;
+}
+
+/*********************************************************************
+ *      ___lc_codepage_func (MSVCRT.@)
+ */
+int CDECL ___lc_codepage_func(void)
+{
+    return MSVCRT___lc_codepage;
+}
+
+/*********************************************************************
+ *      ___lc_collate_cp_func (MSVCRT.@)
+ */
+int CDECL ___lc_collate_cp_func(void)
+{
+    return get_locale()->locinfo->lc_collate_cp;
+}
+
+/* _free_locale - not exported in native msvcrt */
+void CDECL _free_locale(_locale_t locale)
+{
+    int i;
+
+    for(i=MSVCRT_LC_MIN+1; i<=MSVCRT_LC_MAX; i++) {
+        free(locale->locinfo->lc_category[i].locale);
+        free(locale->locinfo->lc_category[i].refcount);
     }
-    UNLOCK_LOCALE;
-    return MSVCRT_current_lc_all;
-  }
 
-  /* Get locale elements */
-  haveLang = haveCountry = haveCP = 0;
-  memset(&lc,0,sizeof(lc));
+    if(locale->locinfo->lconv) {
+        free(locale->locinfo->lconv->decimal_point);
+        free(locale->locinfo->lconv->thousands_sep);
+        free(locale->locinfo->lconv->grouping);
+        free(locale->locinfo->lconv->int_curr_symbol);
+        free(locale->locinfo->lconv->currency_symbol);
+        free(locale->locinfo->lconv->mon_decimal_point);
+        free(locale->locinfo->lconv->mon_thousands_sep);
+        free(locale->locinfo->lconv->mon_grouping);
+        free(locale->locinfo->lconv->positive_sign);
+        free(locale->locinfo->lconv->negative_sign);
+    }
+    free(locale->locinfo->lconv_intl_refcount);
+    free(locale->locinfo->lconv_num_refcount);
+    free(locale->locinfo->lconv_mon_refcount);
+    free(locale->locinfo->lconv);
 
-  next = strchr(locale,'_');
-  if (next && next != locale)
-  {
-    haveLang = 1;
-    memcpy(lc.search_language,locale,next-locale);
-    locale += next-locale+1;
-  }
+    free(locale->locinfo->ctype1_refcount);
+    free(locale->locinfo->ctype1);
 
-  next = strchr(locale,'.');
-  if (next)
-  {
-    haveCP = 1;
-    if (next == locale)
-    {
-      locale++;
-      lstrcpynA(lc.search_codepage, locale, MAX_ELEM_LEN);
+    free((void*)locale->locinfo->pclmap);
+    free((void*)locale->locinfo->pcumap);
+
+    free(locale->locinfo);
+    free(locale->mbcinfo);
+    free(locale);
+}
+
+/* _create_locale - not exported in native msvcrt */
+_locale_t _create_locale(int category, const char *locale)
+{
+    static const char collate[] = "COLLATE=";
+    static const char ctype[] = "CTYPE=";
+    static const char monetary[] = "MONETARY=";
+    static const char numeric[] = "NUMERIC=";
+    static const char time[] = "TIME=";
+
+    _locale_t loc;
+    LCID lcid[6] = { 0 };
+    char buf[256];
+    int i;
+
+    TRACE("(%d %s)\n", category, locale);
+
+    if(category<MSVCRT_LC_MIN || category>MSVCRT_LC_MAX || !locale)
+        return NULL;
+
+    if(locale[0]=='C' && !locale[1])
+        lcid[0] = CP_ACP;
+    else if(!locale[0])
+        lcid[0] = GetSystemDefaultLCID();
+    else if (locale[0] == 'L' && locale[1] == 'C' && locale[2] == '_') {
+        char *p;
+
+        while(1) {
+            locale += 3; /* LC_ */
+            if(!memcmp(locale, collate, sizeof(collate)-1)) {
+                i = MSVCRT_LC_COLLATE;
+                locale += sizeof(collate)-1;
+            } else if(!memcmp(locale, ctype, sizeof(ctype)-1)) {
+                i = MSVCRT_LC_CTYPE;
+                locale += sizeof(ctype)-1;
+            } else if(!memcmp(locale, monetary, sizeof(monetary)-1)) {
+                i = MSVCRT_LC_MONETARY;
+                locale += sizeof(monetary)-1;
+            } else if(!memcmp(locale, numeric, sizeof(numeric)-1)) {
+                i = MSVCRT_LC_NUMERIC;
+                locale += sizeof(numeric)-1;
+            } else if(!memcmp(locale, time, sizeof(time)-1)) {
+                i = MSVCRT_LC_TIME;
+                locale += sizeof(time)-1;
+            } else
+                return NULL;
+
+            p = strchr(locale, ';');
+            if(locale[0]=='C' && (locale[1]==';' || locale[1]=='\0'))
+                lcid[i] = 0;
+            else if(p) {
+                memcpy(buf, locale, p-locale);
+                lcid[i] = MSVCRT_locale_to_LCID(buf);
+            } else
+                lcid[i] = MSVCRT_locale_to_LCID(locale);
+
+            if(lcid[i] == -1)
+                return NULL;
+
+            if(!p || *(p+1)!='L' || *(p+2)!='C' || *(p+3)!='_')
+                break;
+
+            locale = p+1;
+        }
+    } else {
+        lcid[0] = MSVCRT_locale_to_LCID(locale);
+        if(lcid[0] == -1)
+            return NULL;
     }
-    else
-    {
-      if (haveLang)
-      {
-        haveCountry = 1;
-        memcpy(lc.search_country,locale,next-locale);
-        locale += next-locale+1;
-      }
-      else
-      {
-        haveLang = 1;
-        memcpy(lc.search_language,locale,next-locale);
-        locale += next-locale+1;
-      }
-      lstrcpynA(lc.search_codepage, locale, MAX_ELEM_LEN);
+
+    for(i=1; i<6; i++) {
+        if(!lcid[i])
+            lcid[i] = lcid[0];
     }
-  }
-  else
-  {
-    if (haveLang)
-    {
-      haveCountry = 1;
-      lstrcpynA(lc.search_country, locale, MAX_ELEM_LEN);
+
+    loc = malloc(sizeof(_locale_tstruct));
+    if(!loc)
+        return NULL;
+
+    loc->locinfo = malloc(sizeof(threadlocinfo));
+    if(!loc->locinfo) {
+        free(loc);
+        return NULL;
     }
-    else
-    {
-      haveLang = 1;
-      lstrcpynA(lc.search_language, locale, MAX_ELEM_LEN);
+
+    loc->mbcinfo = malloc(sizeof(threadmbcinfo));
+    if(!loc->mbcinfo) {
+        free(loc->locinfo);
+        free(loc);
+        return NULL;
     }
-  }
 
-  if (haveCountry)
-    remap_synonym(lc.search_country);
+    memset(loc->locinfo, 0, sizeof(threadlocinfo));
+    memset(loc->mbcinfo, 0, sizeof(threadmbcinfo));
 
-  if (haveCP && !haveCountry && !haveLang)
-  {
-    ERR(":Codepage only locale not implemented\n");
-    /* FIXME: Use default lang/country and skip locale_to_LCID()
-     * call below...
-     */
-    UNLOCK_LOCALE;
-    return NULL;
-  }
+    loc->locinfo->lconv = malloc(sizeof(struct lconv));
+    if(!loc->locinfo->lconv) {
+        _free_locale(loc);
+        return NULL;
+    }
+    memset(loc->locinfo->lconv, 0, sizeof(struct lconv));
 
-  lcid = MSVCRT_locale_to_LCID(&lc);
+    loc->locinfo->pclmap = malloc(sizeof(char[256]));
+    loc->locinfo->pcumap = malloc(sizeof(char[256]));
+    if(!loc->locinfo->pclmap || !loc->locinfo->pcumap) {
+        _free_locale(loc);
+        return NULL;
+    }
 
-  TRACE(":found LCID %d\n",lcid);
+    loc->locinfo->refcount = 1;
 
-  if (lcid == 0)
-  {
-    UNLOCK_LOCALE;
-    return NULL;
-  }
+    if(lcid[MSVCRT_LC_COLLATE] && (category==MSVCRT_LC_ALL || category==MSVCRT_LC_COLLATE)) {
+        if(update_threadlocinfo_category(lcid[MSVCRT_LC_COLLATE], loc, MSVCRT_LC_COLLATE)) {
+            _free_locale(loc);
+            return NULL;
+        }
+    } else
+        loc->locinfo->lc_category[MSVCRT_LC_COLLATE].locale = _strdup("C");
 
-  MSVCRT_current_lc_all_lcid = lcid;
+    if(lcid[MSVCRT_LC_CTYPE] && (category==MSVCRT_LC_ALL || category==MSVCRT_LC_CTYPE)) {
+        CPINFO cp;
 
-  _snprintf(MSVCRT_current_lc_all,MAX_LOCALE_LENGTH,"%s_%s.%s",
-	   lc.found_language,lc.found_country,lc.found_codepage);
+        if(update_threadlocinfo_category(lcid[MSVCRT_LC_CTYPE], loc, MSVCRT_LC_CTYPE)) {
+            _free_locale(loc);
+            return NULL;
+        }
 
-  switch (category) {
-  case MSVCRT_LC_ALL:
-    lc_all = 1; /* Fall through all cases ... */
-  case MSVCRT_LC_COLLATE:
-    if (!lc_all) break;
-  case MSVCRT_LC_CTYPE:
-    msvcrt_set_ctype(atoi(lc.found_codepage),lcid);
-    if (!lc_all) break;
-  case MSVCRT_LC_MONETARY:
-    if (!lc_all) break;
-  case MSVCRT_LC_NUMERIC:
-    if (!lc_all) break;
-  case MSVCRT_LC_TIME:
-    break;
-  }
-  UNLOCK_LOCALE;
-  return MSVCRT_current_lc_all;
+        loc->locinfo->lc_codepage = loc->locinfo->lc_id[MSVCRT_LC_CTYPE].wCodePage;
+        loc->locinfo->lc_collate_cp = loc->locinfo->lc_codepage;
+        loc->locinfo->lc_clike = 1;
+        if(!GetCPInfo(loc->locinfo->lc_codepage, &cp)) {
+            _free_locale(loc);
+            return NULL;
+        }
+        loc->locinfo->mb_cur_max = cp.MaxCharSize;
+
+        loc->locinfo->ctype1_refcount = malloc(sizeof(int));
+        loc->locinfo->ctype1 = malloc(sizeof(short[257]));
+        if(!loc->locinfo->ctype1_refcount || !loc->locinfo->ctype1) {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        *loc->locinfo->ctype1_refcount = 1;
+        loc->locinfo->ctype1[0] = 0;
+        loc->locinfo->pctype = loc->locinfo->ctype1+1;
+
+        buf[1] = buf[2] = '\0';
+        for(i=1; i<257; i++) {
+            buf[0] = i-1;
+
+            GetStringTypeA(lcid[MSVCRT_LC_CTYPE], CT_CTYPE1, buf,
+                    1, loc->locinfo->ctype1+i);
+            loc->locinfo->ctype1[i] |= 0x200;
+        }
+    } else {
+        loc->locinfo->lc_clike = 1;
+        loc->locinfo->mb_cur_max = 1;
+        loc->locinfo->pctype = (unsigned short*)ctype+1;
+        loc->locinfo->lc_category[MSVCRT_LC_CTYPE].locale = _strdup("C");
+    }
+
+    for(i=0; i<256; i++)
+        buf[i] = i;
+
+    LCMapStringA(lcid[MSVCRT_LC_CTYPE], LCMAP_LOWERCASE, buf, 256,
+            (char*)loc->locinfo->pclmap, 256);
+    LCMapStringA(lcid[MSVCRT_LC_CTYPE], LCMAP_UPPERCASE, buf, 256,
+            (char*)loc->locinfo->pcumap, 256);
+
+    loc->mbcinfo->refcount = 1;
+    loc->mbcinfo->mbcodepage = loc->locinfo->lc_id[MSVCRT_LC_CTYPE].wCodePage;
+
+    for(i=0; i<256; i++) {
+        if(loc->locinfo->pclmap[i] != i) {
+            loc->mbcinfo->mbctype[i+1] |= 0x10;
+            loc->mbcinfo->mbcasemap[i] = loc->locinfo->pclmap[i];
+        } else if(loc->locinfo->pcumap[i] != i) {
+            loc->mbcinfo->mbctype[i+1] |= 0x20;
+            loc->mbcinfo->mbcasemap[i] = loc->locinfo->pcumap[i];
+        }
+    }
+
+    if(lcid[MSVCRT_LC_MONETARY] && (category==MSVCRT_LC_ALL || category==MSVCRT_LC_MONETARY)) {
+        if(update_threadlocinfo_category(lcid[MSVCRT_LC_MONETARY], loc, MSVCRT_LC_MONETARY)) {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        loc->locinfo->lconv_intl_refcount = malloc(sizeof(int));
+        loc->locinfo->lconv_mon_refcount = malloc(sizeof(int));
+        if(!loc->locinfo->lconv_intl_refcount || !loc->locinfo->lconv_mon_refcount) {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        *loc->locinfo->lconv_intl_refcount = 1;
+        *loc->locinfo->lconv_mon_refcount = 1;
+
+        i = GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_SINTLSYMBOL, buf, 256);
+        if(i && (loc->locinfo->lconv->int_curr_symbol = malloc(sizeof(char[i]))))
+            memcpy(loc->locinfo->lconv->int_curr_symbol, buf, sizeof(char[i]));
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        i = GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_SCURRENCY, buf, 256);
+        if(i && (loc->locinfo->lconv->currency_symbol = malloc(sizeof(char[i]))))
+            memcpy(loc->locinfo->lconv->currency_symbol, buf, sizeof(char[i]));
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        i = GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_SMONDECIMALSEP, buf, 256);
+        if(i && (loc->locinfo->lconv->mon_decimal_point = malloc(sizeof(char[i]))))
+            memcpy(loc->locinfo->lconv->mon_decimal_point, buf, sizeof(char[i]));
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        i = GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_SMONTHOUSANDSEP, buf, 256);
+        if(i && (loc->locinfo->lconv->mon_thousands_sep = malloc(sizeof(char[i]))))
+            memcpy(loc->locinfo->lconv->mon_thousands_sep, buf, sizeof(char[i]));
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        i = GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_SMONGROUPING, buf, 256);
+        if(i>1)
+            i = i/2 + (buf[i-2]=='0'?0:1);
+        if(i && (loc->locinfo->lconv->mon_grouping = malloc(sizeof(char[i])))) {
+            for(i=0; buf[i+1]==';'; i+=2)
+                loc->locinfo->lconv->mon_grouping[i/2] = buf[i]-'0';
+            loc->locinfo->lconv->mon_grouping[i/2] = buf[i]-'0';
+            if(buf[i] != '0')
+                loc->locinfo->lconv->mon_grouping[i/2+1] = 127;
+        } else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        i = GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_SPOSITIVESIGN, buf, 256);
+        if(i && (loc->locinfo->lconv->positive_sign = malloc(sizeof(char[i]))))
+            memcpy(loc->locinfo->lconv->positive_sign, buf, sizeof(char[i]));
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        i = GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_SNEGATIVESIGN, buf, 256);
+        if(i && (loc->locinfo->lconv->negative_sign = malloc(sizeof(char[i]))))
+            memcpy(loc->locinfo->lconv->negative_sign, buf, sizeof(char[i]));
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        if(GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_IINTLCURRDIGITS, buf, 256))
+            loc->locinfo->lconv->int_frac_digits = atoi(buf);
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        if(GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_ICURRDIGITS, buf, 256))
+            loc->locinfo->lconv->frac_digits = atoi(buf);
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        if(GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_IPOSSYMPRECEDES, buf, 256))
+            loc->locinfo->lconv->p_cs_precedes = atoi(buf);
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        if(GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_IPOSSEPBYSPACE, buf, 256))
+            loc->locinfo->lconv->p_sep_by_space = atoi(buf);
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        if(GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_INEGSYMPRECEDES, buf, 256))
+            loc->locinfo->lconv->n_cs_precedes = atoi(buf);
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        if(GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_INEGSEPBYSPACE, buf, 256))
+            loc->locinfo->lconv->n_sep_by_space = atoi(buf);
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        if(GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_IPOSSIGNPOSN, buf, 256))
+            loc->locinfo->lconv->p_sign_posn = atoi(buf);
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        if(GetLocaleInfoA(lcid[MSVCRT_LC_MONETARY], LOCALE_INEGSIGNPOSN, buf, 256))
+            loc->locinfo->lconv->n_sign_posn = atoi(buf);
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+    } else {
+        loc->locinfo->lconv->int_curr_symbol = malloc(sizeof(char));
+        loc->locinfo->lconv->currency_symbol = malloc(sizeof(char));
+        loc->locinfo->lconv->mon_decimal_point = malloc(sizeof(char));
+        loc->locinfo->lconv->mon_thousands_sep = malloc(sizeof(char));
+        loc->locinfo->lconv->mon_grouping = malloc(sizeof(char));
+        loc->locinfo->lconv->positive_sign = malloc(sizeof(char));
+        loc->locinfo->lconv->negative_sign = malloc(sizeof(char));
+
+        if(!loc->locinfo->lconv->int_curr_symbol || !loc->locinfo->lconv->currency_symbol
+                || !loc->locinfo->lconv->mon_decimal_point || !loc->locinfo->lconv->mon_thousands_sep
+                || !loc->locinfo->lconv->mon_grouping || !loc->locinfo->lconv->positive_sign
+                || !loc->locinfo->lconv->negative_sign) {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        loc->locinfo->lconv->int_curr_symbol[0] = '\0';
+        loc->locinfo->lconv->currency_symbol[0] = '\0';
+        loc->locinfo->lconv->mon_decimal_point[0] = '\0';
+        loc->locinfo->lconv->mon_thousands_sep[0] = '\0';
+        loc->locinfo->lconv->mon_grouping[0] = '\0';
+        loc->locinfo->lconv->positive_sign[0] = '\0';
+        loc->locinfo->lconv->negative_sign[0] = '\0';
+        loc->locinfo->lconv->int_frac_digits = 127;
+        loc->locinfo->lconv->frac_digits = 127;
+        loc->locinfo->lconv->p_cs_precedes = 127;
+        loc->locinfo->lconv->p_sep_by_space = 127;
+        loc->locinfo->lconv->n_cs_precedes = 127;
+        loc->locinfo->lconv->n_sep_by_space = 127;
+        loc->locinfo->lconv->p_sign_posn = 127;
+        loc->locinfo->lconv->n_sign_posn = 127;
+
+        loc->locinfo->lc_category[MSVCRT_LC_MONETARY].locale = _strdup("C");
+    }
+
+    if(lcid[MSVCRT_LC_NUMERIC] && (category==MSVCRT_LC_ALL || category==MSVCRT_LC_NUMERIC)) {
+        if(update_threadlocinfo_category(lcid[MSVCRT_LC_NUMERIC], loc, MSVCRT_LC_NUMERIC)) {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        if(!loc->locinfo->lconv_intl_refcount)
+            loc->locinfo->lconv_intl_refcount = malloc(sizeof(int));
+        loc->locinfo->lconv_num_refcount = malloc(sizeof(int));
+        if(!loc->locinfo->lconv_intl_refcount || !loc->locinfo->lconv_num_refcount) {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        *loc->locinfo->lconv_intl_refcount = 1;
+        *loc->locinfo->lconv_num_refcount = 1;
+
+        i = GetLocaleInfoA(lcid[MSVCRT_LC_NUMERIC], LOCALE_SDECIMAL, buf, 256);
+        if(i && (loc->locinfo->lconv->decimal_point = malloc(sizeof(char[i]))))
+            memcpy(loc->locinfo->lconv->decimal_point, buf, sizeof(char[i]));
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        i = GetLocaleInfoA(lcid[MSVCRT_LC_NUMERIC], LOCALE_STHOUSAND, buf, 256);
+        if(i && (loc->locinfo->lconv->thousands_sep = malloc(sizeof(char[i]))))
+            memcpy(loc->locinfo->lconv->thousands_sep, buf, sizeof(char[i]));
+        else {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        i = GetLocaleInfoA(lcid[MSVCRT_LC_NUMERIC], LOCALE_SGROUPING, buf, 256);
+        if(i>1)
+            i = i/2 + (buf[i-2]=='0'?0:1);
+        if(i && (loc->locinfo->lconv->grouping = malloc(sizeof(char[i])))) {
+            for(i=0; buf[i+1]==';'; i+=2)
+                loc->locinfo->lconv->grouping[i/2] = buf[i]-'0';
+            loc->locinfo->lconv->grouping[i/2] = buf[i]-'0';
+            if(buf[i] != '0')
+                loc->locinfo->lconv->grouping[i/2+1] = 127;
+        } else {
+            _free_locale(loc);
+            return NULL;
+        }
+    } else {
+        loc->locinfo->lconv->decimal_point = malloc(sizeof(char[2]));
+        loc->locinfo->lconv->thousands_sep = malloc(sizeof(char));
+        loc->locinfo->lconv->grouping = malloc(sizeof(char));
+        if(!loc->locinfo->lconv->decimal_point || !loc->locinfo->lconv->thousands_sep
+                || !loc->locinfo->lconv->grouping) {
+            _free_locale(loc);
+            return NULL;
+        }
+
+        loc->locinfo->lconv->decimal_point[0] = '.';
+        loc->locinfo->lconv->decimal_point[1] = '\0';
+        loc->locinfo->lconv->thousands_sep[0] = '\0';
+        loc->locinfo->lconv->grouping[0] = '\0';
+
+        loc->locinfo->lc_category[MSVCRT_LC_NUMERIC].locale = _strdup("C");
+    }
+
+    if(lcid[MSVCRT_LC_TIME] && (category==MSVCRT_LC_ALL || category==MSVCRT_LC_TIME)) {
+        if(update_threadlocinfo_category(lcid[MSVCRT_LC_TIME], loc, MSVCRT_LC_TIME)) {
+            _free_locale(loc);
+            return NULL;
+        }
+    } else
+        loc->locinfo->lc_category[MSVCRT_LC_TIME].locale = _strdup("C");
+
+    return loc;
 }
 
-/*
- * @unimplemented
- */
-wchar_t* _wsetlocale(int category, const wchar_t* locale)
+/* _configthreadlocale - not exported in native msvcrt */
+int CDECL _configthreadlocale(int type)
 {
-  static wchar_t fake[] = {
-    'E','n','g','l','i','s','h','_','U','n','i','t','e','d',' ',
-    'S','t','a','t','e','s','.','1','2','5','2',0 };
+    MSVCRT_thread_data *data = msvcrt_get_thread_data();
+    int ret;
 
-  TRACE("%d %S\n", category, locale);
+    if(!data)
+        return -1;
 
-  return fake;
-}
+    ret = (data->locale ? _ENABLE_PER_THREAD_LOCALE : _DISABLE_PER_THREAD_LOCALE);
 
-/*
+    if(type == _ENABLE_PER_THREAD_LOCALE) {
+        if(!data->locale) {
+            /* Copy current global locale */
+            data->locale = _create_locale(MSVCRT_LC_ALL, setlocale(MSVCRT_LC_ALL, NULL));
+            if(!data->locale)
+                return -1;
+        }
 
-locale  "lang[_country[.code_page]]"
-            | ".code_page"
-            | ""
-            | NULL
+        return ret;
+    }
 
-*/
-int parse_locale(const char *locale, char *lang, char *country, char *code_page)
+    if(type == _DISABLE_PER_THREAD_LOCALE) {
+        if(data->locale) {
+            _free_locale(data->locale);
+            data->locale = NULL;
+        }
+
+        return ret;
+    }
+
+    if(!type)
+        return ret;
+
+    return -1;
+}
+
+/*********************************************************************
+ *             setlocale (MSVCRT.@)
+ */
+char* CDECL setlocale(int category, const char* locale)
 {
-	while ( *locale != 0 && *locale != '.' && *locale != '_' )
-	{
-		*lang = *locale;
-		lang++;
-		locale++;
-	}
-	*lang = 0;
-	if ( *locale == '_' ) {
-		locale++;
-		while ( *locale != 0 && *locale != '.' )
-		{
-			*country = *locale;
-			country++;
-			locale++;
-		}
-	}
-	*country = 0;
+    _locale_t loc, cur;
 
+    cur = get_locale();
 
-	if ( *locale == '.' ) {
-		locale++;
-		while ( *locale != 0 && *locale != '.' )
-		{
-			*code_page = *locale;
-			code_page++;
-			locale++;
-		}
-	}
+    if(category<MSVCRT_LC_MIN || category>MSVCRT_LC_MAX)
+        return NULL;
 
-	*code_page = 0;
-	return 0;
+    if(!locale) {
+        if(category == MSVCRT_LC_ALL)
+            return construct_lc_all(cur);
+
+        return cur->locinfo->lc_category[category].locale;
+    }
+
+    loc = _create_locale(category, locale);
+    if(!loc) {
+        WARN("%d %s failed\n", category, locale);
+        return NULL;
+    }
+
+    LOCK_LOCALE;
+
+    switch(category) {
+        case MSVCRT_LC_ALL:
+            if(!cur)
+                break;
+        case MSVCRT_LC_COLLATE:
+            cur->locinfo->lc_handle[MSVCRT_LC_COLLATE] =
+                loc->locinfo->lc_handle[MSVCRT_LC_COLLATE];
+            swap_pointers((void**)&cur->locinfo->lc_category[MSVCRT_LC_COLLATE].locale,
+                    (void**)&loc->locinfo->lc_category[MSVCRT_LC_COLLATE].locale);
+            swap_pointers((void**)&cur->locinfo->lc_category[MSVCRT_LC_COLLATE].refcount,
+                    (void**)&loc->locinfo->lc_category[MSVCRT_LC_COLLATE].refcount);
+
+            if(category != MSVCRT_LC_ALL)
+                break;
+        case MSVCRT_LC_CTYPE:
+            cur->locinfo->lc_handle[MSVCRT_LC_CTYPE] =
+                loc->locinfo->lc_handle[MSVCRT_LC_CTYPE];
+            swap_pointers((void**)&cur->locinfo->lc_category[MSVCRT_LC_CTYPE].locale,
+                    (void**)&loc->locinfo->lc_category[MSVCRT_LC_CTYPE].locale);
+            swap_pointers((void**)&cur->locinfo->lc_category[MSVCRT_LC_CTYPE].refcount,
+                    (void**)&loc->locinfo->lc_category[MSVCRT_LC_CTYPE].refcount);
+
+            cur->locinfo->lc_codepage = loc->locinfo->lc_codepage;
+            cur->locinfo->lc_collate_cp = loc->locinfo->lc_collate_cp;
+            cur->locinfo->lc_clike = loc->locinfo->lc_clike;
+            cur->locinfo->mb_cur_max = loc->locinfo->mb_cur_max;
+
+            swap_pointers((void**)&cur->locinfo->ctype1_refcount,
+                    (void**)&loc->locinfo->ctype1_refcount);
+            swap_pointers((void**)&cur->locinfo->ctype1, (void**)&loc->locinfo->ctype1);
+            swap_pointers((void**)&cur->locinfo->pctype, (void**)&loc->locinfo->pctype);
+            swap_pointers((void**)&cur->locinfo->pclmap, (void**)&loc->locinfo->pclmap);
+            swap_pointers((void**)&cur->locinfo->pcumap, (void**)&loc->locinfo->pcumap);
+
+            memcpy(cur->mbcinfo, loc->mbcinfo, sizeof(threadmbcinfo));
+
+            if(category != MSVCRT_LC_ALL)
+                break;
+        case MSVCRT_LC_MONETARY:
+            cur->locinfo->lc_handle[MSVCRT_LC_MONETARY] =
+                loc->locinfo->lc_handle[MSVCRT_LC_MONETARY];
+            swap_pointers((void**)&cur->locinfo->lc_category[MSVCRT_LC_MONETARY].locale,
+                    (void**)&loc->locinfo->lc_category[MSVCRT_LC_MONETARY].locale);
+            swap_pointers((void**)&cur->locinfo->lc_category[MSVCRT_LC_MONETARY].refcount,
+                    (void**)&loc->locinfo->lc_category[MSVCRT_LC_MONETARY].refcount);
+
+            swap_pointers((void**)&cur->locinfo->lconv->int_curr_symbol,
+                    (void**)&loc->locinfo->lconv->int_curr_symbol);
+            swap_pointers((void**)&cur->locinfo->lconv->currency_symbol,
+                    (void**)&loc->locinfo->lconv->currency_symbol);
+            swap_pointers((void**)&cur->locinfo->lconv->mon_decimal_point,
+                    (void**)&loc->locinfo->lconv->mon_decimal_point);
+            swap_pointers((void**)&cur->locinfo->lconv->mon_thousands_sep,
+                    (void**)&loc->locinfo->lconv->mon_thousands_sep);
+            swap_pointers((void**)&cur->locinfo->lconv->mon_grouping,
+                    (void**)&loc->locinfo->lconv->mon_grouping);
+            swap_pointers((void**)&cur->locinfo->lconv->positive_sign,
+                    (void**)&loc->locinfo->lconv->positive_sign);
+            swap_pointers((void**)&cur->locinfo->lconv->negative_sign,
+                    (void**)&loc->locinfo->lconv->negative_sign);
+            cur->locinfo->lconv->int_frac_digits = loc->locinfo->lconv->int_frac_digits;
+            cur->locinfo->lconv->frac_digits = loc->locinfo->lconv->frac_digits;
+            cur->locinfo->lconv->p_cs_precedes = loc->locinfo->lconv->p_cs_precedes;
+            cur->locinfo->lconv->p_sep_by_space = loc->locinfo->lconv->p_sep_by_space;
+            cur->locinfo->lconv->n_cs_precedes = loc->locinfo->lconv->n_cs_precedes;
+            cur->locinfo->lconv->n_sep_by_space = loc->locinfo->lconv->n_sep_by_space;
+            cur->locinfo->lconv->p_sign_posn = loc->locinfo->lconv->p_sign_posn;
+            cur->locinfo->lconv->n_sign_posn = loc->locinfo->lconv->n_sign_posn;
+
+            if(category != MSVCRT_LC_ALL)
+                break;
+        case MSVCRT_LC_NUMERIC:
+            cur->locinfo->lc_handle[MSVCRT_LC_NUMERIC] =
+                loc->locinfo->lc_handle[MSVCRT_LC_NUMERIC];
+            swap_pointers((void**)&cur->locinfo->lc_category[MSVCRT_LC_NUMERIC].locale,
+                    (void**)&loc->locinfo->lc_category[MSVCRT_LC_NUMERIC].locale);
+            swap_pointers((void**)&cur->locinfo->lc_category[MSVCRT_LC_NUMERIC].refcount,
+                    (void**)&loc->locinfo->lc_category[MSVCRT_LC_NUMERIC].refcount);
+
+            swap_pointers((void**)&cur->locinfo->lconv->decimal_point,
+                    (void**)&loc->locinfo->lconv->decimal_point);
+            swap_pointers((void**)&cur->locinfo->lconv->thousands_sep,
+                    (void**)&loc->locinfo->lconv->thousands_sep);
+            swap_pointers((void**)&cur->locinfo->lconv->grouping,
+                    (void**)&loc->locinfo->lconv->grouping);
+
+            if(category != MSVCRT_LC_ALL)
+                break;
+        case MSVCRT_LC_TIME:
+            cur->locinfo->lc_handle[MSVCRT_LC_TIME] =
+                loc->locinfo->lc_handle[MSVCRT_LC_TIME];
+            swap_pointers((void**)&cur->locinfo->lc_category[MSVCRT_LC_TIME].locale,
+                    (void**)&loc->locinfo->lc_category[MSVCRT_LC_TIME].locale);
+            swap_pointers((void**)&cur->locinfo->lc_category[MSVCRT_LC_TIME].refcount,
+                    (void**)&loc->locinfo->lc_category[MSVCRT_LC_TIME].refcount);
+
+            if(category != MSVCRT_LC_ALL)
+                break;
+    }
+
+    if(!cur)
+        MSVCRT_locale = cur = loc;
+    else
+        _free_locale(loc);
+
+    UNLOCK_LOCALE;
+
+    if(cur == MSVCRT_locale) {
+        MSVCRT___lc_codepage = cur->locinfo->lc_codepage;
+        MSVCRT___lc_collate_cp = cur->locinfo->lc_collate_cp;
+        __mb_cur_max = cur->locinfo->mb_cur_max;
+        _pctype = cur->locinfo->pctype;
+    }
+
+    if(category == MSVCRT_LC_ALL)
+        return construct_lc_all(cur);
+
+    return cur->locinfo->lc_category[category].locale;
 }
 
-const struct map_lcid2str {
-        short            langid;
-        const char      *langname;
-	const char	*country;
-} languages[]={
-        {0x0409,"English", "United States"},
-        {0x0809,"English", "United Kingdom"},
-        {0x0000,"Unknown", "Unknown"}
+//from mbcs.c
 
+/* It seems that the data about valid trail bytes is not available from kernel32
+ * so we have to store is here. The format is the same as for lead bytes in CPINFO */
+struct cp_extra_info_t
+{
+    int cp;
+    BYTE TrailBytes[MAX_LEADBYTES];
 };
 
-const struct map_cntr {
-	const char *abrev;
-	const char  *country;
-} abrev[] = {
-	{"britain", "united kingdom"},
-	{"england", "united kingdom"},
-	{"gbr", "united kingdom"},
-	{"great britain", "united kingdom"},
-	{"uk", "united kingdom"},
-	{"united kingdom", "united kingdom"},
-	{"united-kingdom", "united kingdom"},
-	{"america", "united states" },
-	{"united states", "united states"},
-	{"united-states", "united states"},
-	{"us", "united states"},
-	{"usa", "united states"}
+static struct cp_extra_info_t g_cpextrainfo[] =
+{
+    {932, {0x40, 0x7e, 0x80, 0xfc, 0, 0}},
+    {936, {0x40, 0xfe, 0, 0}},
+    {949, {0x41, 0xfe, 0, 0}},
+    {950, {0x40, 0x7e, 0xa1, 0xfe, 0, 0}},
+    {1361, {0x31, 0x7e, 0x81, 0xfe, 0, 0}},
+    {20932, {1, 255, 0, 0}},  /* seems to give different results on different systems */
+    {0, {1, 255, 0, 0}}       /* match all with FIXME */
 };
 
+/*********************************************************************
+ *		___setlc_active_func (MSVCRT.@)
+ */
+unsigned int CDECL ___setlc_active_func(void)
+{
+  return __setlc_active;
+}
 
-struct lconv _lconv = {
-".",   // decimal_point
-",",   // thousands_sep
-"",    // grouping;
-"DOL", // int_curr_symbol
-"$",   // currency_symbol
-".",   // mon_decimal_point
-",",   // mon_thousands_sep
-"",    // mon_grouping;
-"+",   // positive_sign
-"-",   // negative_sign
-127,     // int_frac_digits
-127,     // frac_digits
-127,     // p_cs_precedes
-127,     // p_sep_by_space
-127,     // n_cs_precedes
-127,     // n_sep_by_space
-127,     // p_sign_posn;
-127      // n_sign_posn;
-};
+/*********************************************************************
+ *              ___mb_cur_max_func(MSVCRT.@)
+ */
+int* CDECL MSVCRT___mb_cur_max_func()
+{
+  return &get_locale()->locinfo->mb_cur_max;
+}
 
-/*
- * @implemented
+/*********************************************************************
+ *		___unguarded_readlc_active_add_func (MSVCRT.@)
  */
-struct lconv *localeconv(void)
+unsigned int * CDECL ___unguarded_readlc_active_add_func(void)
 {
-  return (struct lconv *) &_lconv;
+    return &__unguarded_readlc_active;
 }
 
 /*********************************************************************
+ *		__lc_collate_cp (MSVCRT.@)
+ *
+ * @unimplemented
+ */
+void __lc_collate_cp(int cp)
+{
+    FIXME("__lc_collate_cp - stub\n");
+    return;
+}
+
+/*********************************************************************
+ *		__lc_codepage (MSVCRT.@)
+ *
+ * @unimplemented
+ */
+void __lc_codepage(void)
+{
+    FIXME("__lc_codepage - stub\n");
+    return;
+}
+
+/*********************************************************************
+ *		__lc_handle (MSVCRT.@)
+ *
+ * @unimplemented
+ */
+void __lc_handle(void)
+{
+    FIXME("__lc_handle - stub\n");
+    return;
+}
+
+int CDECL _getmbcp(void)
+{
+    return MSVCRT___lc_codepage;
+}
+
+/*********************************************************************
  *		_setmbcp (MSVCRT.@)
- * @implemented
  */
 int CDECL _setmbcp(int cp)
 {
+  _locale_t locale = get_locale();
   int newcp;
   CPINFO cpi;
   BYTE *bytes;
